from youtube import Youtube
from Medium import Medium
from Dev import DevTo
from stof import STOF
import sys
from database import get_database


def saveAnswer(ans_id, stackoverflow, videos, medium_r, dev_r):
    db = get_database()
    try:
        from bson.objectid import ObjectId

        automatedanswers = db["automatedanswers"]
        automatedanswers.update_one(
            {"_id": ObjectId(ans_id)},
            {
                "$set": {
                    "youtube": videos,
                    "stackoverflow": stackoverflow,
                    "medium_articles": medium_r["blogs"],
                    "dev_articles": dev_r["blogs"],
                    "medium_resources": medium_r["resources"],
                    "dev_resources": dev_r["resources"],
                }
            },
        )
        print(
            {
                "youtube": videos,
                "stackoverflow": stackoverflow,
                "medium_articles": medium_r["blogs"],
                "dev_articles": dev_r["blogs"],
                "medium_resources": medium_r["resources"],
                "dev_resources": dev_r["resources"],
            }
        )
    except NameError as err:
        print(err)


if __name__ == "__main__":
    # title = input("Enter question title: ")
    title = sys.argv[1]  # "python django or flask for web development"
    tags = sys.argv[2]  # ["react"]
    AUTO_ANS_ID = sys.argv[3]  # "60dc9a5f84692f001569d7ab"

    stack = STOF(title)
    ans = stack.searchQuestion()
    print(ans)
    medium = Medium(title, tags)
    medium_articels = medium.getMediumArticles()

    devto = DevTo(title, tags)
    dev_articles = devto.getDevArticles()

    youtube = Youtube(title, tags)
    videos = youtube.find_videos()
    saveAnswer(AUTO_ANS_ID, ans, videos, medium_articels, dev_articles)
    print("WORKED")
    sys.stdout.flush()
